<?php

define('VOTE_BAR_WIDTH', 200);

function vote_page(&$page_ar)
{
	global $p_circle,$params,$database,$html,$ut,$plugin_ar;

	$buff = '';
	$p_page = $page_ar['id'];
	if ($page_ar['user'] != $_SESSION['login_id']) {
		return 'Error: edit-rights'; 
	}
	
	//パンくず表示
	$style = '';
	if ($page_ar['type'] == VOTE_ID) { $style = 'vote'; }
	if ($page_ar['type'] == QUIZ_ID) { $style = 'quiz'; }
	snippet_breadcrumb($page_ar['link'], "$style setting");

	$tab_ar=array();
	$tab_ar[]=array('name'=>'basic setting', 'mode'=>null );
	if ($style == 'quiz') {
		$tab_ar[]=array('name'=>'score setting', 'mode'=>'2' );
	}
	$tab_ar[]=array('name'=>'result', 'mode'=>'1' );
	if ($style == 'quiz') {
		$tab_ar[]=array('name'=>'best 100', 'mode'=>'3' );
		$tab_ar[]=array('name'=>'worst 100', 'mode'=>'4' );
	}
	
	if (isset($_GET['tab'])) {
		$p_tab = (int)($_GET['tab']);
	} else {
		$p_tab = 0;
	}

$buff .= <<<EOT
	<div class='onethird-tab'>
		<ul class='tab-head clearfix'>
EOT;
		$i=0;
		for ($i=0; $i<count($tab_ar); ++$i) {
			$v = $tab_ar[$i];
			($i==$p_tab)?$act=" class='active' ":$act='';
			$buff .=("<li $act ><a href='{$ut->link($page_ar['id'],"&:tab=$i")}' >{$v['name']}</a></li>");
		}
$buff .= <<<EOT
		</ul>					
		<div class='tab-body'>
EOT;
		if ($tab_ar[$p_tab]['mode'] === null) {
			 $buff .= basic_setting($p_page, $page_ar);

		} else if ($tab_ar[$p_tab]['mode'] ==2 ) {
			 $buff .= score_level_setting($p_page, $page_ar);

		} else if ($tab_ar[$p_tab]['mode'] ==3 ) {
			 $buff .= score_best_setting($p_page, $page_ar);

		} else if ($tab_ar[$p_tab]['mode'] ==4 ) {
			 $buff .= score_worst_setting($p_page, $page_ar);

		} else if ($tab_ar[$p_tab]['mode'] ==1 ) {
			 $buff .= data_setting($p_page, $page_ar);

		}
$buff .= <<<EOT
		</div>
	</div>
EOT;

$tmp = <<<EOT
<style>
#vote_setting .multiple_answers input[type=text]{
	border-color:#DA8758;
	width:350px;
}
#vote_setting .single_answer input[type=text]{
	border-color:#746F6F;
	width:350px;
}
#vote_setting .choices, #vote_setting .quiz_choices{
	padding-left:20px;
}
#vote_setting .choices input{
	width:330px;
}
#vote_setting .quiz_choices input{
	width:259px;
}
#vote_setting .quiz_choices .score{
	width:50px;
}
#vote_setting .score{
	width:50px;
}
</style>
EOT;
	if (!isset($html['css']['plugin-vote-setting'])) {
		$html['css']['plugin-vote-setting'] = $tmp;
	}

	return frame_renderer($buff);
}

function add_item_html($v = '', $cls = '', $score = '' )
{
	global $ut;
	$add = '';
	if ($score !== '') {
		$add = "<input type='text' placeholder='score' class='score ' value='$score' />";
	}
	return "<li class='$cls'><input type='text' value='$v' class='input_item' /> $add <a href='#' onclick='ot.vote_del_tmp_item(this)' >{$ut->icon('delete')}</a></li>";
}

function basic_setting($p_page, &$page_ar)
{
	global $p_circle,$params,$html,$ut;
	global $database;
	
	$p_title = '';
	$buff = '';
	
	$style = 'vote';
	if ($page_ar['type'] == QUIZ_ID) { $style = 'quiz'; }

$buff .= <<<EOT
<div class='onethird-setting'>
	<table id="vote_setting" >
EOT;
		if ($style == 'quiz') {
			if (isset($page_ar['meta']['plugin']['vote']['option']['title'])) {
				$tilte = $page_ar['meta']['plugin']['vote']['option']['title'];
			} else {
				$tilte = '';
			}
$buff .= <<<EOT
			<tr>
				<td>タイトル</td> 
				</td>
				<td>
					<input type='text' id='p_title' value='{$tilte}'  />
				</td>
			</tr>
EOT;
		}
$buff .= <<<EOT
		<tr>
			<td>items</td> 
			<td>
				<ul id="vote_item" class='sortable'>
EOT;
					if (isset($page_ar['meta']['plugin']['vote']['items'])) {
						foreach ($page_ar['meta']['plugin']['vote']['items'] as $v) {
							$score = '';
							if ($v['att'] == 1) {
								$cls = 'single_answer';

							} else if ($v['att'] == 2) {
								$cls = 'multiple_answers';

							} else if ($v['att'] == 3) {
								$cls = 'quiz_choices';
								if (!isset($v['score']) || !$v['score']) { $v['score'] = 0; }
								$score = $v['score'];
							} else {
								$cls = 'choices';
							}
							$buff .= add_item_html($v['data'], $cls, $score);
						}
					}
$buff .= <<<EOT
					<li>
						<input type='button' onclick='ot.vote_add_tmp_item(this,1)' value='質問追加'  class='onethird-button mini'  />
EOT;
						if ($style != 'quiz') {
$buff .= <<<EOT
							<input type='button' onclick='ot.vote_add_tmp_item(this,2)' value='質問追加(複数回答)' class='onethird-button mini'  />
EOT;
						}
$buff .= <<<EOT
						<input type='button' onclick='ot.vote_add_tmp_item(this,0)' value='選択肢追加' class='onethird-button mini'  />
					</li>
				</ul>
			</td>
		<tr>

EOT;
		if ($style != 'quiz') {
$buff .= <<<EOT
			<tr>
				<td>option</td> 
				<td>
					<ul>
EOT;
						(isset($page_ar['meta']['plugin']['vote']['option']['reinput']))? $checked = 'checked': $checked = '' ;
$buff .= <<<EOT
						<li><label><input type='checkbox' name='p_reinput' id='p_reinput' $checked >投票の修正を許可する</label></li>
EOT;
						(isset($page_ar['meta']['plugin']['vote']['option']['disp_voted']))? $checked = 'checked': $checked = '' ;
$buff .= <<<EOT
						<li><label><input type='checkbox' name='p_disp_voted' id='p_disp_voted' $checked >集計結果を表示する</label></li>
EOT;
						(isset($page_ar['meta']['plugin']['vote']['option']['guest_vote']))? $checked = 'checked': $checked = '' ;
$buff .= <<<EOT
						<li><label><input type='checkbox' name='p_disp_voted' id='p_guest_vote' $checked >ゲスト投票を許可する</label></li>
					</ul>
				</td>
			<tr>
EOT;
		}
$buff .= <<<EOT

	</table>
	<div class='actions' >
		<input type='button' value='更新' onclick='ot.vote_save()' />
	</div>
</div>
EOT;

	$add_item_html2 = $add_item_html = add_item_html('');
	$choices = 'choices';
	if ($style == 'quiz') {
		$add_item_html2 = add_item_html('','',0);
		$choices = 'quiz_choices';
	}
	
$html['meta'][] = <<<EOT
	<script>
	\$(function() {
		\$(document).on('click','.input_item',function(){
			ot.focus = this;
		});
	});
	ot.vote_save = function (obj,mode) {
		var opt = '';
		
		if (\$('#p_title').length) { opt +='&title='+encodeURIComponent(\$('#p_title').val()); }
		
		\$('#vote_item .input_item').each(function(){
			var o = \$(this);
			var p = o.parent();
			 opt += '&item_d[]='+encodeURIComponent(o.val());
			if (p.hasClass('single_answer')) {
				 opt += '&item_a[]=1';
				 opt += '&item_s[]=0';
			} else if (p.hasClass('multiple_answers')) {
				 opt += '&item_a[]=2';
				 opt += '&item_s[]=0';
			} else if (p.hasClass('quiz_choices')) {
				 opt += '&item_a[]=3';
				 opt += '&item_s[]='+encodeURIComponent(o.next().val());
			} else if (p.hasClass('choices')) {
				 opt += '&item_a[]=0';
				 opt += '&item_s[]=0';
			}
		});
		if (\$('#vote_setting #p_reinput').prop('checked')) {
			opt += "&reinput=true";
		}
		if (\$('#vote_setting #p_disp_voted').prop('checked')) {
			opt += "&disp_voted=true";
		}
		if (\$('#vote_setting #p_guest_vote').prop('checked')) {
			opt += "&guest_vote=true";
		}
		
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=vote_save"+opt
			, dataType:'json'
			, success: function(data) {
				if ( data && data['result'] ) {
					alert('update successfully.');
					location.reload(true);
				} else {
					alert('update failed.');
				}
			}
		});
	}
	ot.vote_add_tmp_item = function (obj,mode) {
		var o = \$(ot.focus);
		var p = false;
		if (o.length) {
			p = o.parent();
		} 
		if (mode == 1) {	//add question(single answer)
			item = \$("$add_item_html").addClass('single_answer');
			if (p) {
				if (p.hasClass('multiple_answers')) {
					p.removeClass('multiple_answers').addClass('single_answer');
				} else {
					p.before(item);
				}
			} else {
				\$(obj).parent().before(item);
			}
		} else if (mode == 2) {//add question(multiple answers)
			item = \$("$add_item_html").addClass('multiple_answers');
			if (p) {
				if (p.hasClass('single_answer')) {
					p.removeClass('single_answer').addClass('multiple_answers');
				} else {
					p.before(item);
				}
			} else {
				\$(obj).parent().before(item);
			}
		} else {	//add choices
			item = \$("$add_item_html2").addClass('$choices');
			if (p) {
				p.after(item);
			} else {
				\$(obj).parent().before(item);
			}
		}
	}
	ot.vote_del_tmp_item = function (obj) {
		\$(obj).parent().remove();
	}
	</script>
EOT;
	if (isset($_POST['ajax']) && $_POST['ajax'] == 'vote_save')  {
		$r = array();
		$r['result'] = false;

		if (!isset($_POST['item_d'])) {
			echo( json_encode($r) );
			exit();
		}
		
		$ar = array();
		for ($i=0; $i <count($_POST['item_d']); ++$i) {
			$att = (isset($_POST['item_a'][$i])) ? (int)$_POST['item_a'][$i] : 0;
			$score = (isset($_POST['item_s'][$i])) ? (int)$_POST['item_s'][$i] : 0;
			$m = array('data'=>sanitize_str($_POST['item_d'][$i]), 'att'=>(int)$_POST['item_a'][$i]);
			if ($score) {
				$m['score'] = (int)$_POST['item_s'][$i];
			}
			$ar[] = $m;
		}
		if (isset($_POST['reinput'])) {
			$page_ar['meta']['plugin']['vote']['option']['reinput'] = true;
		} else {
			unset($page_ar['meta']['plugin']['vote']['option']['reinput']);
		}
		if (isset($_POST['disp_voted'])) {
			$page_ar['meta']['plugin']['vote']['option']['disp_voted'] = true;
		} else {
			unset($page_ar['meta']['plugin']['vote']['option']['disp_voted']);
		}
		if (isset($_POST['guest_vote'])) {
			$page_ar['meta']['plugin']['vote']['option']['guest_vote'] = true;
		} else {
			unset($page_ar['meta']['plugin']['vote']['option']['guest_vote']);
		}
		if (isset($_POST['title'])) {
			$page_ar['meta']['plugin']['vote']['option']['title'] = sanitize_str($_POST['title']);
		} else {
			unset($page_ar['meta']['plugin']['vote']['option']['title']);
		}
		$page_ar['meta']['plugin']['vote']['items'] = $ar;
		$x = array();
		$x['id'] = $page_ar['id'];
		$x['meta'] = $page_ar['meta'];
		if (mod_data_items($x)) {
			$r['result'] = true;
		}

		echo( json_encode($r) );
		exit();
	}

	return $buff;
}

function add_score_item_html($v = '', $score = '' )
{
	global $ut;
	return "<li><input type='text' value='$v' class='input_item' /> <input type='text' placeholder='score' class='score ' value='$score' /> <a href='#' onclick='ot.vote_del_tmp_item(this)' >{$ut->icon('delete')}</a></li>";
}

function score_level_setting($p_page, &$page_ar)
{
	global $p_circle,$params,$html,$ut;
	global $database;
	
	$p_title = '';
	$buff = '';
	
	if (isset($page_ar['meta']['plugin']['vote']['option']['score_mess'])) {
		$score_mess = $page_ar['meta']['plugin']['vote']['option']['score_mess'];
	} else {
		$score_mess = 'Your Score is ';
	}

$buff .= <<<EOT
<div class='onethird-setting'>
	<table id="vote_setting" >
		<tr>
			<td>score message</td> 
			</td>
			<td>
				<input type='text' id='p_title' value='{$score_mess}'  />
			</td>
		</tr>
		<tr>
			<td>score level</td> 
			<td>
				<ul id="vote_item" class='sortable'>
EOT;
					if (isset($page_ar['meta']['plugin']['vote']['score_level'])) {
						foreach ($page_ar['meta']['plugin']['vote']['score_level'] as $v) {
							$buff .= add_score_item_html($v['data'],$v['score']);
						}
					}
$buff .= <<<EOT
					<li>
						<input type='button' onclick='ot.score_add_tmp_item(this)' value='スコアを追加する' class='onethird-button mini'  />
					</li>
				</ul>
			</td>
		</tr>
		<tr>
			<td>option</td> 
			<td>
				<ul>
EOT;
					(isset($page_ar['meta']['plugin']['vote']['option']['show_score']))? $checked = 'checked': $checked = '' ;
$buff .= <<<EOT
					<li><label><input type='checkbox' name='p_show_score' id='p_show_score' $checked >スコアを表示する</label></li>
EOT;
$buff .= <<<EOT
				</ul>
			<td>
		</tr>
	</table>
	<div class='actions' >
		<input type='button' value='更新' onclick='ot.score_level_save()' />
	</div>
</div>
EOT;
	$add_item_html = add_score_item_html();
$html['meta'][] = <<<EOT
	<script>
	\$(function() {
		\$(document).on('click','.input_item',function(){
			ot.focus = this;
		});
	});
	ot.score_level_save = function (obj,mode) {
		var opt = '';
		\$('#vote_item .input_item').each(function(){
			var o = \$(this);
			var p = o.parent();
			 opt += '&item_d[]='+encodeURIComponent(o.val());
			 opt += '&item_s[]='+encodeURIComponent(o.next().val());
		});
		if (\$('#vote_setting #p_show_score').prop('checked')) {
			opt += "&show_score=true";
		}
		if (\$('#p_title').length) { opt +='&title='+encodeURIComponent(\$('#p_title').val()); }
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=score_level_save"+opt
			, dataType:'json'
			, success: function(data) {
				if ( data && data['result'] ) {
					location.reload(true);
				} else {
					alert('update failed.');
				}
			}
		});
	}
	ot.score_add_tmp_item = function (obj) {
		var o = \$(ot.focus);
		var p = false;
		if (o.length) {
			p = o.parent();
		} 
		item = \$("$add_item_html").addClass('');
		if (p) {
			p.after(item);
		} else {
			\$(obj).parent().before(item);
		}
	}
	ot.vote_del_tmp_item = function (obj) {
		\$(obj).parent().remove();
	}
	</script>
EOT;
	if (isset($_POST['ajax']) && $_POST['ajax'] == 'score_level_save')  {
		$r = array();
		$r['result'] = false;

		if (isset($_POST['item_d'])) {
			$ar = array();
			for ($i=0; $i < count($_POST['item_d']); ++$i) {
				$score = (isset($_POST['item_s'][$i])) ? (int)$_POST['item_s'][$i] : 0;
				if (!$_POST['item_d'][$i]) { continue; }
				$m = array('data'=>sanitize_str($_POST['item_d'][$i]), 'score'=>(int)$_POST['item_s'][$i]);
				$ar[] = $m;
			}
			function score_level_cmp($a, $b) {
				if ($a['score'] == $b['score']) {
					return 0;
				}
				return ($a['score'] > $b['score']) ? -1 : 1;
			}
			usort($ar, "score_level_cmp");
			$page_ar['meta']['plugin']['vote']['score_level'] = $ar;
		} else {
			unset($page_ar['meta']['plugin']['vote']['score_level']);
		}
		if (isset($_POST['show_score'])) {
			$page_ar['meta']['plugin']['vote']['option']['show_score'] = true;
		} else {
			unset($page_ar['meta']['plugin']['vote']['option']['show_score']);
		}
		if (isset($_POST['title'])) {
			$page_ar['meta']['plugin']['vote']['option']['score_mess'] = sanitize_str($_POST['title']);
		} else {
			unset($page_ar['meta']['plugin']['vote']['option']['score_mess']);
		}
		$x = array();
		$x['id'] = $page_ar['id'];
		$x['meta'] = $page_ar['meta'];
		if (mod_data_items($x)) {
			$r['result'] = true;
		}
		echo( json_encode($r) );
		exit();
	}

	return $buff;
}

function score_best_setting($p_page, &$page_ar)
{
	return score_listing(100, $p_page, $page_ar);
}

function score_worst_setting($p_page, &$page_ar)
{
	return score_listing(-100, $p_page, $page_ar);
}

function score_listing($list_score, $p_page, &$page_ar)
{
	global $p_circle,$params,$html,$config,$ut;
	global $database;
	$buff = '';

$buff .= <<<EOT
<div class='onethird-setting'>
	<div id="vote_result" >
EOT;

	if ($list_score > 0) {
		$order = " order by status desc limit ".(int)$list_score;
	} else {
		$order = " order by status limit ".(int)$list_score;
	}

	$vote_result = array();
	$t = DBX."user_log";
	$ar = $database->sql_select_all("select $t.status as status, $t.id as id, t1.name as name, t1.nickname as nickname, $t.user as user, {$ut->date_format("$t.date","'%m/%d %H:%i'")} as date,t1.img as img from $t left join ".DBX."users as t1 on t1.id=$t.user where $t.type=? and $t.link=? $order", $page_ar['type'], $page_ar['id'] );
	if ($ar) {
		$buff .= "<div class='vote-result-panel'>";
		foreach ($ar as $v) {
			$buff .= "<p>{$v['date']} : {$v['name']} : {$v['nickname']} : {$v['status']}</p>";
		}
		$buff .= "</div>";
	} else {
$buff .= <<<EOT
		<div class='vote-result-panel'>
			...
		</div>
EOT;
	}

$buff .= <<<EOT
	</div>
</div>
EOT;
	return $buff;
}

function data_setting($p_page, &$page_ar)
{
	global $p_circle,$params,$html,$config,$ut;
	global $database;
	$buff = '';

$buff .= <<<EOT
<div class='onethird-setting'>
	<div id="vote_result" >
EOT;

	$buff .= get_result_html($p_page, $page_ar);

$buff .= <<<EOT
	</div>
	<div class='actions' >
		<input type='button' value='投票結果をクリアする'  onclick='ot.vote_reset()' />
	</div>
</div>
EOT;

$html['meta'][] = <<<EOT
	<script>
	\$(function() {
	});
	ot.vote_reset = function () {
		if (!confirm('投票結果をクリアしますか?')) { return; }
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=vote_reset"
			, dataType:'json'
			, success: function(data) {
				if (data['result']) {
					location.reload(true);
				} else {
					alert('update failed.');
				}
			}
		});
	}
	</script>
EOT;

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'vote_reset')  {
		$r = array();
		$r['result'] = false;

		if ($database->sql_update("delete from ".DBX."user_log where type=? and link=? ", $page_ar['type'], $page_ar['id'] )) {
			$r['result'] = true;
		}
		
		echo(json_encode($r));
		exit();
	}

	return $buff;
}

function get_result_html($p_page, &$page_ar)
{
	global $p_circle,$params,$html,$config,$ut;
	global $database;
	$buff = '';

	vote_css();
	
	if (!isset($page_ar['meta']['plugin']['vote']['items'])) {
		return ' ... ';
	}

	$vote_ar = $page_ar['meta']['plugin']['vote']['items'];
	$vote_title = array();
	$i = 1;
	foreach ($vote_ar as $v) {
		if ($v['att'] != 0) {
			$vote_title[$i++] = $v['data'];
		}
	}
	$vote_result = array();
	$ar = $database->sql_select_all("select data,id,metadata from ".DBX."user_log where type=? and link=? ", $page_ar['type'], $page_ar['id'] );
	if ($ar) {
		$count = count($ar);
		foreach ($ar as $v) {
			$m = $v['data'];
			$lines = explode("\n",$m);
			$idx = false;
			foreach ($lines as $item) {
				if ($item) {
					if (substr($item,0,2) == 'Q:') {
						$idx = substr($item,2);
					} else if (substr($item,0,2) == 'A:') {
						if ($idx) {
							if (!isset($vote_result[$idx][substr($item,2)])) {
								$vote_result[$idx][substr($item,2)] = 0;
							}
							++$vote_result[$idx][substr($item,2)];
						}
					}
				}
			}
		}
		$buff .= "<div class='vote-result-panel'>";
		foreach ($vote_result as $k=>$v) {
			if (isset($vote_title[$k])) {
				$buff .= "<p>{$vote_title[$k]} </p>";
			}
			foreach ($v as $ans=>$item) {
				$p = (int)(($item*100)/$count);
				$w = (int)VOTE_BAR_WIDTH*$item/$count;
$buff .= <<<EOT
				<div class='item' >
					<div class='cap'>$ans</div>
					<div class='ind'>
						<div class='bar' style='width:{$w}px'></div>
						<div >{$p}% ($item/$count)</div>
					</div>
				</div>
EOT;
			}
		}
		$buff .= "<p><button class='onethird-button' onclick='location.reload(true)' >reload</button></p>";
		$buff .= "</div>";
	} else {
		$buff = " ... ";
	}

	return $buff;
}

function vote_create( &$page_ar )
{
	global $database;
	$database->sql_update( "update ".DBX."data_items set mode=? where id=?", 1, $page_ar['id'] );
}

function vote_css()
{
	global $html;
	$bar_width = VOTE_BAR_WIDTH;

	if (!isset($html['css']['plugin-vote'])) {
$html['css']['plugin-vote'] = <<<EOT
		<style>
		.vote-panel {
			margin-left: auto;
			margin-right: auto;
			min-width: 300px;
			background-color: #E4E4E4;
			padding: 5px 30px 11px 33px;
			border: 1px solid #B6B4B4;
		}
		.vote-result-panel {
			margin-left: auto;
			margin-right: auto;
			min-width: 300px;
			background-color: #E4E4E4;
			padding: 5px 30px 11px 33px;
			border: 1px solid #B6B4B4;
		}
		.vote-result-panel .item {
			position: relative;
			height:2em;
		}
		.vote-result-panel .item .cap {
			position: absolute;
			left:10px;
			top:0;
			background-color: #BACAFF;
			width:100px;
			overflow: hidden;
			height:1.5em;
			padding:2px 5px 2px 5px;
		}
		.vote-result-panel .item .ind {
			position: absolute;
			text-align: center;
			left:150px;
			width:{$bar_width}px;
			top:0;
			border:1px solid #BACAFF;
			z-index:1;
			overflow: hidden;
		}
		.vote-result-panel .item .bar {
			position: absolute;
			left:0;
			top:0;
			width:1px;
			background-color: #BACAFF;
			height: 2em;
			z-index: -1;
		}
		</style>
EOT;
	}
}

function vote_renderer( &$page_ar )
{
	global $database,$params,$ut;
	global $html;
	
	$p_page = $page_ar['id'];
	
	if (isset($_POST['ajax']))  {
		// 複数のインナーページプラグインの修正を受け入れる
		if (!isset($_POST['id'])) { return; }
		if ($p_page != (int)$_POST['id']) { return; }
	}
	
	vote_css();
	
	$revote_disabled = '';
	$buff = '';
	
	$ip_addr = sanitize_asc($_SERVER["REMOTE_ADDR"]);
	if (!check_rights() && !isset($page_ar['meta']['plugin']['vote']['option']['guest_vote'])) {
		return frame_renderer(" Please Login to use this page. ");
	}

	if (!check_rights() && isset($page_ar['meta']['plugin']['vote']['option']['guest_vote'])) {
		$ar = $database->sql_select_all("select data,id,status from ".DBX."user_log where att=? and user=0 and type=? and link=? ", $ip_addr, $page_ar['type'], $page_ar['id'] );
	} else {
		$ar = $database->sql_select_all("select data,id,status from ".DBX."user_log where user=? and type=? and link=? ", $_SESSION['login_id'], $page_ar['type'], $page_ar['id'] );
	}
	$vote_score = 0;
	$vote_result = array();
	if ($ar) {
		$vote_score = $ar[0]['status'];
		$m = $ar[0]['data'];
		$lines = explode("\n",$m);
		$idx = false;
		foreach ($lines as $v) {
			if ($v) {
				if (substr($v,0,2) == 'Q:') {
					$idx = $v;
				} else if (substr($v,0,2) == 'A:') {
					if ($idx) {
						$vote_result[$idx][substr($v,2)] = true;
					}
				}
			}
		}
		if (!isset($page_ar['meta']['plugin']['vote']['option']['reinput'])) {
			$revote_disabled = ' disabled ';
		}
	}

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'do_vote')  {
		$r = array();
		$r['result'] = false;
	
		if (!isset($_POST['data']) || !$_POST['data']) {
			echo( json_encode($r) );
			exit();
		}
		$page_id = (int)$_POST['id'];
		$data = sanitize_str($_POST['data']);
		if (!$data) {
			echo( json_encode($r) );
			exit();
		}

		if (!$ar) {
			$x = array();
			$x['link'] = $page_ar['id'];
			$x['type'] = $page_ar['type'];
			$x['att'] = $ip_addr;
			if (add_user_log($x)) {
			}
			if (!check_rights() && isset($page_ar['meta']['plugin']['vote']['option']['guest_vote'])) {
				$ar = $database->sql_select_all("select data,id,metadata from ".DBX."user_log where att=? and user=0 and type=? and link=? ", $ip_addr, $page_ar['type'], $page_ar['id'] );
			} else {
				$ar = $database->sql_select_all("select data,id,metadata from ".DBX."user_log where user=? and type=? and link=? ", $_SESSION['login_id'], $page_ar['type'], $page_ar['id'] );
			}
		}
		if (!$ar) {
			echo( json_encode($r) );
			exit();
		}
		$lines = explode("\n",$data);
		$score = 0;
		foreach ($lines as $v) {
			if ($v) {
				if (substr($v,0,2) == 'A:') {
					foreach ($page_ar['meta']['plugin']['vote']['items'] as $vv) {
						if ($v == "A:".$vv['data'] && isset($vv['score'])) {
							$score += $vv['score'];
						}
					}
				}
			}
		}
		$x = array();
		$x['status'] = $score;
		$x['id'] = $ar[0]['id'];
		$x['data'] = $data;
		if (mod_user_log($x)) {
			$r['result'] = true;
		}
		echo( json_encode($r) );
		exit();
	}

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'show_voted')  {
		$r = array();
		$r['result'] = true;
		$r['html'] = get_result_html($p_page, $page_ar);
		echo( json_encode($r) );
		exit();
	}

	if (!isset($page_ar['meta']['plugin']['vote'])) {
		if (check_rights('edit') && !isset($page_ar['meta']['plugin']['vote']['option']['guest_vote'])) {
$buff .= <<<EOT
			- setting is not defined -
EOT;
		}
	} else {
		if ($page_ar['type'] == QUIZ_ID) {
			$buff .= quiz_renderer_item( $page_ar, $revote_disabled, $vote_result, $vote_score );
		} else {
			$buff .= vote_renderer_item( $page_ar, $revote_disabled, $vote_result, $vote_score );
		}
	}

	if (!check_rights()) {
		provide_onethird_object();
	}
$tmp = <<<EOT
	<script>
	ot.do_vote = function(id) {
		var a ='';
		\$("#vote-unit-"+id+" input[name*='vote_data_']").each(function(){
			var x = \$(this);
			if (x.prop('checked')) {
				a += "\\nQ:"+x.attr("data-id");
				a += "\\nA:"+x.val();
			}
		});
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=do_vote&data="+encodeURIComponent(a)+"&id="+id
			, dataType:'json'
			, success: function(data) {
				if (data['result']) {
					location.reload(true);
				} else {
					alert('update failed.');
				}
			}
		});
	}
	ot.show_voted = function(id) {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=show_voted&id="+id
			, dataType:'json'
			, idx: id
			, success: function(data) {
				if (data['html']) {
					\$('#vote-unit-'+this.idx).fadeOut(200,
						function(){
							\$(this).html(data['html']).fadeIn();
						}
					);
					
				} else {
					alert('update failed.');
				}
			}
		});
	}
	</script>
EOT;
	$html['meta']['vote'] = $tmp;

	//管理者メニュー
	if (check_rights('edit')) {
$buff .= <<<EOT
		<div class='edit_pointer'>
EOT;
			$buff .= std_blockmenu_renderer($page_ar);
$buff .= <<<EOT
			<a href='{$ut->link($p_page)}' >{$ut->icon('setting')}</a>
		</div>
EOT;
	}

	return frame_renderer($buff);
}

function vote_renderer_item( &$page_ar, $disabled, &$vote_result, $vote_score )
{
	global $database,$params,$ut;

	$p_page = $page_ar['id'];

	$buff = '';
	if (!isset($page_ar['meta']['plugin']['vote']['items'])) {
		return ' ... ';
	}

$buff .= <<<EOT
	<div class='vote-unit' id ='vote-unit-{$p_page}'>
		<div class='vote-panel'>
EOT;
		$vote_ar = $page_ar['meta']['plugin']['vote']['items'];
		$mod = 'radio';
		$idx = 0;
		foreach ($vote_ar as $v) {
			if ($v['att'] == 1) {
				$mod = 'radio';
				$buff .= "<p>{$v['data']}</p>";
				++$idx;
			} else if ($v['att'] == 2) {
				$mod = 'checkbox';
				$buff .= "<p>{$v['data']}</p>";
				++$idx;
			} else {
				$checked = '';
				if (isset($vote_result["Q:$idx"][$v['data']])) {
					$checked = 'checked';
				}
				if ($mod =='radio') {
					$buff .= "<label><input type='radio' value='{$v['data']}' name='vote_data_$idx' data-id='$idx' $checked $disabled /> {$v['data']} </label><br />";
				} else {
					$buff .= "<label><input type='checkbox' value='{$v['data']}' name='vote_data_$idx' data-id='$idx'  $checked $disabled /> {$v['data']} </label><br />";
				}
			}
		}

$buff .= <<<EOT
		<p>
EOT;
		if (!$disabled) {
			$buff .= "<input type='button' value='投票する' onclick='ot.do_vote($p_page)' class='onethird-button' > ";
		}

		if (isset($page_ar['meta']['plugin']['vote']['option']['disp_voted'])) {
			$buff .= "<input type='button' value='結果を見る' onclick='ot.show_voted($p_page)' class='onethird-button' >";
		}

$buff .= <<<EOT
		</p>
		</div>
	</div>
EOT;

	return $buff;
}

function quiz_renderer_item( &$page_ar, $disabled, &$vote_result, $vote_score )
{
	global $database,$params,$ut,$html;

	$p_page = $page_ar['id'];

	if (!isset($html['css']['plugin-quiz'])) {
$html['css']['plugin-quiz'] = <<<EOT
		<style>
		.quiz-unit {
			margin-left: auto;
			margin-right: auto;
			min-width: 300px;
			background-color: #E4E4E4;
			border: 1px solid #949494;
			font-size:150%;
		}
		.quiz-unit .tilte {
			border-bottom: 1px solid #949494;
			padding: 10px 30px 10px 33px;
			background-color: #CACACA;
		}
		.quiz-unit .panel {
			padding: 30px 30px 30px 33px;
		}
		.quiz-unit .quiz-item {
			float:left;
			display:none;
			padding: 25px 30px 21px 33px;
		}
		</style>
EOT;
	}

$html['meta'][] = <<<EOT
<script>
	\$(function(){
		var w = \$('.quiz-panel').width();
		\$('.quiz-unit .quiz-item:first').fadeIn(1000)
	});
	ot.quiz_next = function(obj) {
		\$(obj).parents(".quiz-item").fadeOut(100,function(){
			\$(this).next().fadeIn(200);
		});
	}
</script>
EOT;

	$buff = '';
	if ($vote_result) {
		if (!isset($page_ar['meta']['plugin']['vote']['option']['show_score'])) {
			return '既に解答済みです';
		}
		if (isset($page_ar['meta']['plugin']['vote']['score_level'])) {
			foreach ($page_ar['meta']['plugin']['vote']['score_level'] as $v) {
				if ($vote_score >= $v['score']) {
					$vote_score = $v['data'];
					break;
				}
			}
		}
		if (isset($page_ar['meta']['plugin']['vote']['option']['score_mess'])) {
			$score_mess = $page_ar['meta']['plugin']['vote']['option']['score_mess'];
		} else {
			$score_mess = 'Your Score is ';
		}
		$t = '';
		if (isset($page_ar['meta']['plugin']['vote']['option']['title'])) {
			$t = "<div class='tilte'>{$page_ar['meta']['plugin']['vote']['option']['title']}</div>";
		}
$buff .= <<<EOT
		<div class='quiz-unit clearfix'>
			$t
			<div class='panel'>
				{$score_mess}{$vote_score}
			</div>
		</div>
EOT;
		return $buff;
	}
	
	if (!isset($page_ar['meta']['plugin']['vote']['items'])) {
		return ' ... ';
	}

$buff .= <<<EOT
		<div id ='vote-unit-{$p_page}'>
			<div class='quiz-unit clearfix'>
EOT;
			if (isset($page_ar['meta']['plugin']['vote']['option']['title'])) {
$buff .= <<<EOT
				<div class='tilte'>
					{$page_ar['meta']['plugin']['vote']['option']['title']}
				</div>
				<div class='quiz-item'>
					<input type='button' value='解答を開始する' onclick='ot.quiz_next(this)' />
				</div>
EOT;
			}
			$vote_ar = $page_ar['meta']['plugin']['vote']['items'];
			$mod = 'radio';
			$idx = 0;
			$tmp ='';
			foreach ($vote_ar as $v) {
				$n = "<p><input type='button' value='次へ' onclick='ot.quiz_next(this)' /></p>";

				if ($v['att'] == 1) {
					if ($tmp) { $buff .= "<div class='quiz-item'>$tmp $n</div>"; $tmp='';}
					$mod = 'radio';
					$tmp .= "<p>{$v['data']}</p>";
					++$idx;
				} else if ($v['att'] == 2) {
					if ($tmp) { $buff .= "<div class='quiz-item'>$tmp $n</div>"; $tmp='';}
					$mod = 'checkbox';
					$tmp .= "<p>{$v['data']}</p>";
					++$idx;
				} else {
					$checked = '';
					if (isset($vote_result["Q:$idx"][$v['data']])) {
						$checked = 'checked';
					}
					if ($mod =='radio') {
						$tmp .= "<label><input type='radio' value='{$v['data']}' name='vote_data_$idx' data-id='$idx' $checked $disabled /> {$v['data']} </label><br />";
					} else {
						$tmp .= "<label><input type='checkbox' value='{$v['data']}' name='vote_data_$idx' data-id='$idx'  $checked $disabled /> {$v['data']} </label><br />";
					}
				}
			}
			if ($tmp) {
$buff .= <<<EOT
				<div class='quiz-item'>
					$tmp
					<p>
EOT;
					if (!$disabled) {
						$buff .= "<input type='button' value='完了' onclick='ot.do_vote($p_page)' > ";
					}

					if (isset($page_ar['meta']['plugin']['vote']['option']['disp_voted'])) {
						$buff .= "<input type='button' value='view result' onclick='ot.show_voted($p_page)' >";
					}
$buff .= <<<EOT
					</p>
				</div>
EOT;
			}

$buff .= <<<EOT
			</div>
		</div>
EOT;

	return $buff;
}


?>